Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 1319)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 1320)
@@ -21,12 +21,15 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
 ! -----------------
 ! $Id$
-!
-! 1318 2014-03-17 13:35:16Z raasch
-! module interfaces removed
 !
 ! 1299 2014-03-06 13:15:21Z heinze
@@ -66,98 +69,4 @@
 ! 801 2012-01-10 17:30:36Z suehring
 ! Calculation of turbulent fluxes in advec_ws is now thread-safe.
-!
-! 743 2011-08-18 16:10:16Z suehring
-! Calculation of turbulent fluxes with WS-scheme only for the whole model
-! domain, not for user-defined subregions. 
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 699 2011-03-22 17:52:22Z suehring
-! Bugfix in calculation of vertical velocity skewness. The added absolute value
-! avoid negative values in the root. Negative values of w'w' can occur at the
-! top or bottom of the model domain due to degrading the order of advection 
-! scheme. Furthermore the calculation will be the same for all advection
-! schemes.
-!, tend
-! 696 2011-03-18 07:03:49Z raasch
-! Bugfix: Summation of Wicker-Skamarock scheme fluxes and variances for all
-! threads
-!
-! 678 2011-02-02 14:31:56Z raasch
-! Bugfix in calculation of the divergence of vertical flux of resolved scale
-! energy, pressure fluctuations, and flux of pressure fluctuation itself
-!
-! 673 2011-01-18 16:19:48Z suehring
-! Top bc for the horizontal velocity variances added for ocean runs.
-! Setting the corresponding bottom bc moved to advec_ws.
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! When advection is computed with ws-scheme, turbulent fluxes are already
-! computed in the respective advection routines and buffered in arrays
-! sums_xx_ws_l(). This is due to a consistent treatment of statistics with the
-! numerics and to avoid unphysical kinks near the surface. 
-! So some if requests has to be done to dicern between fluxes from ws-scheme
-! other advection schemes. 
-! Furthermore the computation of z_i is only done if the heat flux exceeds a
-! minimum value. This affects only simulations of a neutral boundary layer and
-! is due to reasons of computations in the advection scheme.
-!
-! 624 2010-12-10 11:46:30Z heinze
-! Calculation of q*2 added
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 388 2009-09-23 09:40:33Z raasch
-! Vertical profiles of potential density and hydrostatic pressure are
-! calculated.
-! Added missing timeseries calculation of w"q"(0), moved timeseries q* to the
-! end.
-! Temperature gradient criterion for estimating the boundary layer height
-! replaced by the gradient criterion of Sullivan et al. (1998).
-! Output of messages replaced by message handling routine.
-!
-! 197 2008-09-16 15:29:03Z raasch
-! Spline timeseries splptx etc. removed, timeseries w'u', w'v', w'q' (k=0)
-! added,
-! bugfix: divide sums(k,8) (e) and sums(k,34) (e*) by ngp_2dh_s_inner(k,sr) 
-! (like other scalars)
-!
-! 133 2007-11-20 10:10:53Z letzel
-! Vertical profiles now based on nzb_s_inner; they are divided by 
-! ngp_2dh_s_inner (scalars, procucts of scalars) and ngp_2dh (staggered 
-! velocity components and their products, procucts of scalars and velocity 
-! components), respectively.
-!
-! 106 2007-08-16 14:30:26Z raasch
-! Prescribed momentum fluxes at the top surface are used,
-! profiles for w*p* and w"e are calculated
-!
-! 97 2007-06-21 08:23:15Z raasch
-! Statistics for ocean version (salinity, density) added,
-! calculation of z_i and Deardorff velocity scale adjusted to be used with
-! the ocean version
-!
-! 87 2007-05-22 15:46:47Z raasch
-! Two more arguments added to user_statistics, which is now also called for
-! user-defined profiles,
-! var_hom and var_sum renamed pr_palm
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Cpp-directive lcmuk changed to intel_openmp_bug
-!
-! 75 2007-03-22 09:54:05Z raasch
-! Collection of time series quantities moved from routine flow_statistics to
-! here, routine user_statistics is called for each statistic region,
-! moisture renamed humidity
-!
-! 19 2007-02-23 04:53:48Z raasch
-! fluxes at top modified (tswst, qswst)
-! 
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.41  2006/08/04 14:37:50  raasch
-! Error removed in non-parallel part (sums_l)
 !
 ! Revision 1.1  1997/08/11 06:15:17  raasch
@@ -177,21 +86,61 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY :  ddzu, ddzw, e, hyp, km, kh,nr,  p, prho, pt, q, qc, ql, qr,    &
+                qs, qsws, qswst, rho, sa, saswsb, saswst, shf, ts, tswst, u,   &
+                ug, us, usws, uswst, vsws, v, vg, vpt, vswst, w, w_subs, zw
+        
+    USE cloud_parameters,                                                      &
+        ONLY :  l_d_cp, prr, pt_d_t
+        
+    USE control_parameters,                                                    &
+        ONLY :  average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
+                dt_3d, g, humidity, icloud_scheme, kappa, max_pr_user,         &
+                message_string, ocean, passive_scalar, precipitation,          &
+                use_surface_fluxes, use_top_fluxes, ws_scheme_mom, ws_scheme_sca
+        
+    USE cpulog,                                                                &
+        ONLY :  cpu_log, log_point
+        
+    USE grid_variables,                                                        &
+        ONLY :  ddx, ddy
+        
+    USE indices,                                                               &
+        ONLY :  ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums, nxl, &
+                nxr, nyn, nys, nzb, nzb_diff_s_inner, nzb_s_inner, nzt, nzt_diff
+        
+    USE kinds
+    
     USE pegrid
+    
     USE statistics
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, omp_get_thread_num, sr, tn
-    LOGICAL ::  first
-    REAL    ::  dptdz_threshold, height, pts, sums_l_eper, sums_l_etot, ust, &
-                ust2, u2, vst, vst2, v2, w2, z_i(2)
-    REAL    ::  dptdz(nzb+1:nzt+1)
-    REAL    ::  sums_ll(nzb:nzt+1,2)
+    INTEGER(iwp) ::  i                   !:
+    INTEGER(iwp) ::  j                   !:
+    INTEGER(iwp) ::  k                   !:
+    INTEGER(iwp) ::  omp_get_thread_num  !:
+    INTEGER(iwp) ::  sr                  !:
+    INTEGER(iwp) ::  tn                  !:
+    
+    LOGICAL ::  first  !:
+    
+    REAL(wp) ::  dptdz_threshold  !: 
+    REAL(wp) ::  height           !:
+    REAL(wp) ::  pts              !:
+    REAL(wp) ::  sums_l_eper      !:
+    REAL(wp) ::  sums_l_etot      !:
+    REAL(wp) ::  ust              !:
+    REAL(wp) ::  ust2             !:
+    REAL(wp) ::  u2               !:
+    REAL(wp) ::  vst              !:
+    REAL(wp) ::  vst2             !:
+    REAL(wp) ::  v2               !:
+    REAL(wp) ::  w2               !:
+    REAL(wp) ::  z_i(2)           !:
+    
+    REAL(wp) ::  dptdz(nzb+1:nzt+1)    !:
+    REAL(wp) ::  sums_ll(nzb:nzt+1,2)  !:
 
     CALL cpu_log( log_point(10), 'flow_statistics', 'start' )
@@ -248,11 +197,11 @@
              sums_l(:,31,i) = sums_vs2_ws_l(:,i)        ! v*2 
              sums_l(:,32,i) = sums_ws2_ws_l(:,i)        ! w*2 
-             sums_l(:,34,i) = sums_l(:,34,i) + 0.5 *                        & 
-                              ( sums_us2_ws_l(:,i) + sums_vs2_ws_l(:,i) +   &
+             sums_l(:,34,i) = sums_l(:,34,i) + 0.5 *                           & 
+                              ( sums_us2_ws_l(:,i) + sums_vs2_ws_l(:,i) +      &
                                 sums_ws2_ws_l(:,i) )    ! e*
              DO  k = nzb, nzt
-                sums_l(nzb+5,pr_palm,i) = sums_l(nzb+5,pr_palm,i) + 0.5 * ( &
-                                                      sums_us2_ws_l(k,i) +  &
-                                                      sums_vs2_ws_l(k,i) +  &
+                sums_l(nzb+5,pr_palm,i) = sums_l(nzb+5,pr_palm,i) + 0.5 * (    &
+                                                      sums_us2_ws_l(k,i) +     &
+                                                      sums_vs2_ws_l(k,i) +     &
                                                       sums_ws2_ws_l(k,i) )
              ENDDO
@@ -382,30 +331,30 @@
 !--    Compute total sum from local sums
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), nzt+2-nzb, MPI_REAL, &
+       CALL MPI_ALLREDUCE( sums_l(nzb,1,0), sums(nzb,1), nzt+2-nzb, MPI_REAL,  &
                            MPI_SUM, comm2d, ierr )
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,2,0), sums(nzb,2), nzt+2-nzb, MPI_REAL, &
+       CALL MPI_ALLREDUCE( sums_l(nzb,2,0), sums(nzb,2), nzt+2-nzb, MPI_REAL,  &
                            MPI_SUM, comm2d, ierr )
        IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-       CALL MPI_ALLREDUCE( sums_l(nzb,4,0), sums(nzb,4), nzt+2-nzb, MPI_REAL, &
+       CALL MPI_ALLREDUCE( sums_l(nzb,4,0), sums(nzb,4), nzt+2-nzb, MPI_REAL,  &
                            MPI_SUM, comm2d, ierr )
        IF ( ocean )  THEN
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,23,0), sums(nzb,23), nzt+2-nzb, &
+          CALL MPI_ALLREDUCE( sums_l(nzb,23,0), sums(nzb,23), nzt+2-nzb,       &
                               MPI_REAL, MPI_SUM, comm2d, ierr )
        ENDIF
        IF ( humidity ) THEN
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,44,0), sums(nzb,44), nzt+2-nzb, &
+          CALL MPI_ALLREDUCE( sums_l(nzb,44,0), sums(nzb,44), nzt+2-nzb,       &
                               MPI_REAL, MPI_SUM, comm2d, ierr )
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb, &
+          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb,       &
                               MPI_REAL, MPI_SUM, comm2d, ierr )
           IF ( cloud_physics ) THEN
              IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-             CALL MPI_ALLREDUCE( sums_l(nzb,42,0), sums(nzb,42), nzt+2-nzb, &
+             CALL MPI_ALLREDUCE( sums_l(nzb,42,0), sums(nzb,42), nzt+2-nzb,    &
                                  MPI_REAL, MPI_SUM, comm2d, ierr )
              IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-             CALL MPI_ALLREDUCE( sums_l(nzb,43,0), sums(nzb,43), nzt+2-nzb, &
+             CALL MPI_ALLREDUCE( sums_l(nzb,43,0), sums(nzb,43), nzt+2-nzb,    &
                                  MPI_REAL, MPI_SUM, comm2d, ierr )
           ENDIF
@@ -414,5 +363,5 @@
        IF ( passive_scalar )  THEN
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb, &
+          CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb,       &
                               MPI_REAL, MPI_SUM, comm2d, ierr )
        ENDIF
@@ -468,5 +417,5 @@
 !
 !--    Passive scalar
-       IF ( passive_scalar )  hom(:,1,41,sr) = sums(:,41) /  &
+       IF ( passive_scalar )  hom(:,1,41,sr) = sums(:,41) /                    &
             ngp_2dh_s_inner(:,sr)                    ! s (q)
 
@@ -527,14 +476,14 @@
 !
 !--          2D-arrays (being collected in the last column of sums_l)
-             sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +   &
+             sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
                                         us(j,i)   * rmask(j,i,sr)
-             sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) + &
+             sums_l(nzb+1,pr_palm,tn) = sums_l(nzb+1,pr_palm,tn) +             &
                                         usws(j,i) * rmask(j,i,sr)
-             sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) + &
+             sums_l(nzb+2,pr_palm,tn) = sums_l(nzb+2,pr_palm,tn) +             &
                                         vsws(j,i) * rmask(j,i,sr)
-             sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) + &
+             sums_l(nzb+3,pr_palm,tn) = sums_l(nzb+3,pr_palm,tn) +             &
                                         ts(j,i)   * rmask(j,i,sr)
              IF ( humidity )  THEN
-                sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) + &
+                sums_l(nzb+12,pr_palm,tn) = sums_l(nzb+12,pr_palm,tn) +        &
                                             qs(j,i)   * rmask(j,i,sr)
              ENDIF
@@ -1349,22 +1298,68 @@
  SUBROUTINE flow_statistics
 
-    USE arrays_3d
-    USE cloud_parameters
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  ddzu, ddzw, e, hyp, km, kh,nr,  p, prho, pt, q, qc, ql, qr,     &
+               qs, qsws, qswst, rho, sa, saswsb, saswst, shf, ts, tswst, u,    &
+               ug, us, usws, uswst, vsws, v, vg, vpt, vswst, w, w_subs, zw
+        
+    USE cloud_parameters,                                                      &
+        ONLY:  l_d_cp, prr, pt_d_t
+        
+    USE control_parameters,                                                    &
+        ONLY:  average_count_pr, cloud_droplets, cloud_physics, do_sum,        &
+               dt_3d, g, humidity, icloud_scheme, kappa, max_pr_user,          &
+               message_string, ocean, passive_scalar, precipitation,           &
+               use_surface_fluxes, use_top_fluxes, ws_scheme_mom, ws_scheme_sca
+        
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+        
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy
+        
+    USE indices,                                                               &
+        ONLY:  ngp_2dh, ngp_2dh_s_inner, ngp_3d, ngp_3d_inner, ngp_sums, nxl,  &
+               nxr, nyn, nys, nzb, nzb_diff_s_inner, nzb_s_inner, nzt, nzt_diff
+        
+    USE kinds
+    
     USE pegrid
+    
     USE statistics
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, omp_get_thread_num, sr, tn
-    LOGICAL ::  first
-    REAL    ::  dptdz_threshold, height, pts, sums_l_eper, sums_l_etot, ust, &
-                ust2, u2, vst, vst2, v2, w2, z_i(2)
-    REAL    ::  s1, s2, s3, s4, s5, s6, s7
-    REAL    ::  dptdz(nzb+1:nzt+1)
-    REAL    ::  sums_ll(nzb:nzt+1,2)
+    INTEGER(iwp) ::  i                   !:
+    INTEGER(iwp) ::  j                   !:
+    INTEGER(iwp) ::  k                   !:
+    INTEGER(iwp) ::  omp_get_thread_num  !:
+    INTEGER(iwp) ::  sr                  !:
+    INTEGER(iwp) ::  tn                  !:
+    
+    LOGICAL ::  first  !:
+    
+    REAL(wp) ::  dptdz_threshold  !:
+    REAL(wp) ::  height           !:
+    REAL(wp) ::  pts              !:
+    REAL(wp) ::  sums_l_eper      !:
+    REAL(wp) ::  sums_l_etot      !:
+    REAL(wp) ::  s1               !:
+    REAL(wp) ::  s2               !:
+    REAL(wp) ::  s3               !:
+    REAL(wp) ::  s4               !:
+    REAL(wp) ::  s5               !:
+    REAL(wp) ::  s6               !:
+    REAL(wp) ::  s7               !:
+    REAL(wp) ::  ust              !:
+    REAL(wp) ::  ust2             !:
+    REAL(wp) ::  u2,              !:
+    REAL(wp) ::  vst              !:
+    REAL(wp) ::  vst2             !:
+    REAL(wp) ::  v2               !:
+    REAL(wp) ::  w2               !:
+    REAL(wp) ::  z_i(2)           !:
+
+    REAL(wp) ::  dptdz(nzb+1:nzt+1)    !:
+    REAL(wp) ::  sums_ll(nzb:nzt+1,2)  !:
 
     CALL cpu_log( log_point(10), 'flow_statistics', 'start' )
Index: /palm/trunk/SOURCE/global_min_max.f90
===================================================================
--- /palm/trunk/SOURCE/global_min_max.f90	(revision 1319)
+++ /palm/trunk/SOURCE/global_min_max.f90	(revision 1320)
@@ -21,5 +21,11 @@
 ! Current revisions:
 ! ------------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -35,17 +41,4 @@
 ! 866 2012-03-28 06:44:41Z raasch
 ! new mode "absoff" accounts for an offset in the respective array
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Adapting of the index arrays, because MINLOC assumes lowerbound at 1 and not 
-! at nbgp.
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! Feb. 2007
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.11  2003/04/16 12:56:58  raasch
-! Index values of the extrema are limited to the range 0..nx, 0..ny
 !
 ! Revision 1.1  1997/07/24 11:14:03  raasch
@@ -58,25 +51,52 @@
 !------------------------------------------------------------------------------!
 
-    USE indices
+    USE indices,                                                               &
+        ONLY:  nbgp, ny, nx
+        
+    USE kinds
+    
     USE pegrid
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode
-
-    INTEGER           ::  i, i1, i2, id_fmax, id_fmin, j, j1, j2, k, k1, k2, &
-                          fmax_ijk(3), fmax_ijk_l(3), fmin_ijk(3), &
-                          fmin_ijk_l(3), value_ijk(3)
-    INTEGER, OPTIONAL ::  value1_ijk(3)
-    REAL              ::  offset, value, &
-                          ar(i1:i2,j1:j2,k1:k2)
+    CHARACTER (LEN=*) ::  mode  !:
+
+    INTEGER(iwp) ::  i              !:
+    INTEGER(iwp) ::  i1             !:
+    INTEGER(iwp) ::  i2             !:
+    INTEGER(iwp) ::  id_fmax        !:
+    INTEGER(iwp) ::  id_fmin        !:
+    INTEGER(iwp) ::  j              !:
+    INTEGER(iwp) ::  j1             !:
+    INTEGER(iwp) ::  j2             !:
+    INTEGER(iwp) ::  k              !:
+    INTEGER(iwp) ::  k1             !:
+    INTEGER(iwp) ::  k2             !:
+    INTEGER(iwp) ::  fmax_ijk(3)    !:
+    INTEGER(iwp) ::  fmax_ijk_l(3)  !:
+    INTEGER(iwp) ::  fmin_ijk(3)    !:
+    INTEGER(iwp) ::  fmin_ijk_l(3)  !:
+    INTEGER(iwp) ::  value_ijk(3)   !:
+    
+    INTEGER(iwp), OPTIONAL ::  value1_ijk(3)  !:
+    
+    REAL(wp) ::  offset                 !:
+    REAL(wp) ::  value                  !:
+    REAL(wp) ::  ar(i1:i2,j1:j2,k1:k2)  !:
+    
 #if defined( __ibm )
-    REAL (KIND=4)     ::  fmax(2), fmax_l(2), fmin(2), fmin_l(2)  ! on 32bit-
-                          ! machines MPI_2REAL must not be replaced by
-                          ! MPI_2DOUBLE_PRECISION
-#else
-    REAL              ::  fmax(2), fmax_l(2), fmin(2), fmin_l(2)
-#endif
-    REAL, OPTIONAL    ::  value1
+    REAL(sp) ::  fmax(2)    !:
+    REAL(sp) ::  fmax_l(2)  !:
+    REAL(sp) ::  fmin(2)    !:
+    REAL(sp) ::  fmin_l(2)  !:
+             ! on 32bit-machines MPI_2REAL must not be replaced 
+             ! by MPI_2DOUBLE_PRECISION
+#else
+    REAL(wp) ::  fmax(2)    !:
+    REAL(wp) ::  fmax_l(2)  !:
+    REAL(wp) ::  fmin(2)    !:
+    REAL(wp) ::  fmin_l(2)  !:
+#endif
+    REAL(wp), OPTIONAL ::  value1  !:
 
 
Index: /palm/trunk/SOURCE/header.f90
===================================================================
--- /palm/trunk/SOURCE/header.f90	(revision 1319)
+++ /palm/trunk/SOURCE/header.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements, 
+! kinds are defined in new module kinds, 
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements 
 !
 ! Former revisions:
@@ -108,91 +114,4 @@
 ! 825 2012-02-19 03:03:44Z raasch
 ! Output of cloud physics parameters/quantities complemented and restructured
-!
-! 767 2011-10-14 06:39:12Z raasch
-! Output of given initial u,v-profiles
-!
-! 759 2011-09-15 13:58:31Z raasch
-! output of maximum number of parallel io streams
-!
-! 707 2011-03-29 11:39:40Z raasch
-! bc_lr/ns replaced by bc_lr/ns_cyc
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Output of advection scheme.
-! Modified output of Prandtl-layer height.
-!
-! 580 2010-10-05 13:59:11Z heinze
-! Renaming of ws_vertical_gradient to subs_vertical_gradient,
-! ws_vertical_gradient_level to subs_vertical_gradient_level and
-! ws_vertical_gradient_level_ind to subs_vertical_gradient_level_i
-!
-! 493 2010-03-01 08:30:24Z raasch
-! NetCDF data output format extendend for NetCDF4/HDF5
-!
-! 449 2010-02-02 11:23:59Z raasch
-! +large scale vertical motion (subsidence/ascent)
-! Bugfix: index problem concerning gradient_level indices removed
-!
-! 410 2009-12-04 17:05:40Z letzel
-! Masked data output: + dt_domask, mask_01~20_x|y|z, mask_01~20_x|y|z_loop, 
-! mask_scale|_x|y|z, masks, skip_time_domask
-!
-! 346 2009-07-06 10:13:41Z raasch
-! initializing_actions='read_data_for_recycling' renamed to 'cyclic_fill'
-! Coupling with independent precursor runs.
-! Output of messages replaced by message handling routine.
-! Output of several additional dvr parameters
-! +canyon_height, canyon_width_x, canyon_width_y, canyon_wall_left,
-! canyon_wall_south, conserve_volume_flow_mode, dp_external, dp_level_b, 
-! dp_smooth, dpdxy, u_bulk, v_bulk
-! topography_grid_convention moved from user_header
-! small bugfix concerning 3d 64bit netcdf output format
-!
-! 206 2008-10-13 14:59:11Z raasch
-! Bugfix: error in zu index in case of section_xy = -1
-!
-! 198 2008-09-17 08:55:28Z raasch
-! Format adjustments allowing output of larger revision numbers
-!
-! 197 2008-09-16 15:29:03Z raasch
-! allow 100 spectra levels instead of 10 for consistency with 
-! define_netcdf_header,
-! bugfix in the output of the characteristic levels of potential temperature, 
-! geostrophic wind, scalar concentration, humidity and leaf area density,
-! output of turbulence recycling informations
-!
-! 138 2007-11-28 10:03:58Z letzel
-! Allow new case bc_uv_t = 'dirichlet_0' for channel flow.
-! Allow two instead of one digit to specify isosurface and slicer variables.
-! Output of sorting frequency of particles
-!
-! 108 2007-08-24 15:10:38Z letzel
-! Output of informations for coupled model runs (boundary conditions etc.)
-! + output of momentumfluxes at the top boundary
-! Rayleigh damping for ocean, e_init
-!
-! 97 2007-06-21 08:23:15Z raasch
-! Adjustments for the ocean version.
-! use_pt_reference renamed use_reference
-!
-! 87 2007-05-22 15:46:47Z raasch
-! Bugfix: output of use_upstream_for_tke
-!
-! 82 2007-04-16 15:40:52Z raasch
-! Preprocessor strings for different linux clusters changed to "lc",
-! routine local_flush is used for buffer flushing
-!
-! 76 2007-03-29 00:58:32Z raasch
-! Output of netcdf_64bit_3d, particles-package is now part of the default code,
-! output of the loop optimization method, moisture renamed humidity,
-! output of subversion revision number
-!
-! 19 2007-02-23 04:53:48Z raasch
-! Output of scalar flux applied at top boundary
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.63  2006/08/22 13:53:13  raasch
-! Output of dz_max
 !
 ! Revision 1.1  1997/08/11 06:17:20  raasch
@@ -209,38 +128,111 @@
 !-----------------------------------------------------------------------------!
 
-    USE arrays_3d
+    USE arrays_3d,                                                             &
+        ONLY:  lad, pt_init, qsws, q_init, sa_init, shf, ug, vg, w_subs, zu
+        
     USE control_parameters
-    USE cloud_parameters
-    USE cpulog
-    USE dvrp_variables
-    USE grid_variables
-    USE indices
-    USE model_1d
-    USE particle_attributes
+        
+    USE cloud_parameters,                                                      &
+        ONLY:  cp, curvature_solution_effects, c_sedimentation,                &
+               limiter_sedimentation, l_v, nc_const, r_d, ventilation_effect
+        
+    USE cpulog,                                                                &
+        ONLY:  log_point_s
+        
+    USE dvrp_variables,                                                        &
+        ONLY:  use_seperate_pe_for_dvrp_output
+        
+    USE grid_variables,                                                        &
+        ONLY:  dx, dy
+        
+    USE indices,                                                               &
+        ONLY:  mg_loc_ind, nnx, nny, nnz, nx, ny, nxl_mg, nxr_mg, nyn_mg,      &
+               nys_mg, nzt, nzt_mg
+        
+    USE kinds
+    
+    USE model_1d,                                                              &
+        ONLY:  damp_level_ind_1d, dt_pr_1d, dt_run_control_1d, end_time_1d
+        
+    USE particle_attributes,                                                   &
+        ONLY:  bc_par_b, bc_par_lr, bc_par_ns, bc_par_t, collision_kernel,     &
+               density_ratio, dissipation_classes, dt_min_part, dt_prel,       &
+               dt_sort_particles, dt_write_particle_data, end_time_prel,       &
+               maximum_number_of_tailpoints, maximum_tailpoint_age,            &
+               minimum_tailpoint_distance, number_of_particle_groups,          &
+               particle_advection, particle_advection_start,                   &
+               particles_per_point, pdx, pdy, pdz,  psb, psl, psn, psr, pss,   &
+               pst, radius, radius_classes, random_start_position,             &
+               total_number_of_particles, use_particle_tails,                  &
+               use_sgs_for_particles, total_number_of_tails,                   &
+               vertical_particle_advection, write_particle_statistics
+        
     USE pegrid
-    USE subsidence_mod
-    USE spectrum
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=1)  ::  prec
-    CHARACTER (LEN=2)  ::  do2d_mode
-    CHARACTER (LEN=5)  ::  section_chr
-    CHARACTER (LEN=10) ::  coor_chr, host_chr
-    CHARACTER (LEN=16) ::  begin_chr
-    CHARACTER (LEN=26) ::  ver_rev
-    CHARACTER (LEN=40) ::  output_format
-    CHARACTER (LEN=70) ::  char1, char2, dopr_chr, &
-                           do2d_xy, do2d_xz, do2d_yz, do3d_chr, &
-                           domask_chr, run_classification
-    CHARACTER (LEN=86) ::  coordinates, gradients, learde, slices,  &
-                           temperatures, ugcomponent, vgcomponent
-    CHARACTER (LEN=85) ::  roben, runten
-
-    CHARACTER (LEN=1), DIMENSION(1:3) ::  dir = (/ 'x', 'y', 'z' /)
-
-    INTEGER ::  av, bh, blx, bly, bxl, bxr, byn, bys, ch, count, cwx, cwy,  &
-                cxl, cxr, cyn, cys, dim, i, io, j, l, ll, mpi_type
-    REAL    ::  cpuseconds_per_simulated_second
+    CHARACTER (LEN=1)  ::  prec                !:
+    
+    CHARACTER (LEN=2)  ::  do2d_mode           !:
+    
+    CHARACTER (LEN=5)  ::  section_chr         !:
+    
+    CHARACTER (LEN=10) ::  coor_chr            !:
+    CHARACTER (LEN=10) ::  host_chr            !:
+    
+    CHARACTER (LEN=16) ::  begin_chr           !:
+    
+    CHARACTER (LEN=26) ::  ver_rev             !:
+    
+    CHARACTER (LEN=40) ::  output_format       !:
+    
+    CHARACTER (LEN=70) ::  char1               !:
+    CHARACTER (LEN=70) ::  char2               !:
+    CHARACTER (LEN=70) ::  dopr_chr            !:
+    CHARACTER (LEN=70) ::  do2d_xy             !:
+    CHARACTER (LEN=70) ::  do2d_xz             !:
+    CHARACTER (LEN=70) ::  do2d_yz             !:
+    CHARACTER (LEN=70) ::  do3d_chr            !:
+    CHARACTER (LEN=70) ::  domask_chr          !:
+    CHARACTER (LEN=70) ::  run_classification  !:
+    
+    CHARACTER (LEN=85) ::  roben               !:
+    CHARACTER (LEN=85) ::  runten              !:
+    
+    CHARACTER (LEN=86) ::  coordinates         !:
+    CHARACTER (LEN=86) ::  gradients           !:
+    CHARACTER (LEN=86) ::  learde              !:
+    CHARACTER (LEN=86) ::  slices              !:
+    CHARACTER (LEN=86) ::  temperatures        !:
+    CHARACTER (LEN=86) ::  ugcomponent         !:
+    CHARACTER (LEN=86) ::  vgcomponent         !:
+
+    CHARACTER (LEN=1), DIMENSION(1:3) ::  dir = (/ 'x', 'y', 'z' /)  !:
+
+    INTEGER(iwp) ::  av        !:
+    INTEGER(iwp) ::  bh        !:
+    INTEGER(iwp) ::  blx       !:
+    INTEGER(iwp) ::  bly       !:
+    INTEGER(iwp) ::  bxl       !:
+    INTEGER(iwp) ::  bxr       !:
+    INTEGER(iwp) ::  byn       !:
+    INTEGER(iwp) ::  bys       !:
+    INTEGER(iwp) ::  ch        !:
+    INTEGER(iwp) ::  count     !:
+    INTEGER(iwp) ::  cwx       !:
+    INTEGER(iwp) ::  cwy       !:
+    INTEGER(iwp) ::  cxl       !:
+    INTEGER(iwp) ::  cxr       !:
+    INTEGER(iwp) ::  cyn       !:
+    INTEGER(iwp) ::  cys       !:
+    INTEGER(iwp) ::  dim       !:
+    INTEGER(iwp) ::  i         !:
+    INTEGER(iwp) ::  io        !:
+    INTEGER(iwp) ::  j         !:
+    INTEGER(iwp) ::  l         !:
+    INTEGER(iwp) ::  ll        !:
+    INTEGER(iwp) ::  mpi_type  !:
+    
+    REAL(wp) ::  cpuseconds_per_simulated_second  !:
 
 !
